/*----------------------------------------------------------------
 * variable.c - definice hlavnich typu
 *----------------------------------------------------------------
 */

#include <allegro.h>
#include <time.h>
#include "variable.h"


//SMAZAT: GROUND_MAP_STRUCTURE ground_map[X_MAP_SIZE][Y_MAP_SIZE];

PALETTE pal;

BITMAP *mouse_pointer;
BITMAP *mouse_pointer2;
BITMAP *mouse_shot;
BITMAP *game_screen;
BITMAP *game_screen2;
BITMAP *bfont1;
BITMAP *bfont2;
BITMAP *bstar1;
BITMAP *bhole[HOLES_TYPE_COUNT];	// diry ve zdi (bitmapy)
BITMAP *bmhole;
BITMAP *bhead[3];	// hlava sherifa
BITMAP *bbang;	// bank pres obrazovku
BITMAP *bcheat_life;	// ikonka cheatu zivotu
BITMAP *bcheat_civil;	// ikonka cheatu strileni civilu




VRSTVA_STRUCTURE vrstva[VRSTVA_COUNT];
OBJECT_STRUCTURE object[OBJECT_COUNT];
SMALL_OBJECT_STRUCTURE small_object[SMALL_OBJECT_COUNT];
//SMALL_OBJECT_STRUCTURE creature[MAX_CREATURE_COUNT];
DVERE_OBJECT_STRUCTURE dvere[SMALL_OBJECT_COUNT];
int object_count = 0;
int small_object_count = 0;
//int creature_count = 0;


int level = 0, next_level = 0;	//game level a nasledujici level
//char *komix_start, *komix_finish;	// pripadne komixy na zacatku a na konci
char komix_start[50], komix_finish[50];	// pripadne komixy na zacatku a na konci



ANIM_OBJECT_STRUCTURE *kolt_anim;
ANIM_OBJECT_STRUCTURE *nabojnik_anim;
//ANIM_OBJECT_STRUCTURE *shot_anim;


int kolt_X, kolt_X_old;
KOLT_OBJECT_STRUCTURE kolt[7];
int pocet_naboju = 6, max_pocet_naboju = 6, celkem_naboju=44;
long shot_last_time, reload_last_time;
int shot_show, reload_show;
int pocet_hitu, pocet_zivotu, pocet_zabitych, score;
int max_doors_open;	// kolik dveri najednou muze byt otevreno
int refresh_door;	// jak casto se objevuji kovbojove, od 0 do 1000
int level_mode;
int level_time, max_level_bandit;
int max_pravdepodobnost;
int obtiznost = 0;	// level obtiznosti, na 0 (nejlehci) se samo nabiji
					// na 1 se nabiji najednou a na 2 se nabiji po nabojich
DECORATION_STRUCTURE decoration[DECORATION_COUNT];
int decoration_count;
int mouse_sensitivity;



DIRA_STRUCT dira[MAX_POCET_DER];


/*
//SMAZAT BITMAP *ground_tile[GROUND_TILE_COUNT];
GROUND_TILE_STRUCTURE ground_tile[GROUND_TILE_COUNT];
ROOF_TILE_STRUCTURE roof_tile[ROOF_TILE_COUNT];
int ground_tile_count = 0;
*/

int color_depth;
//int fps;    // pocet framu
long old_cas;  // cas posledniho testu fps
long spec_cas;
// nyni uz v mape int map_height, map_width;	// velikost aktualni mapy
int pos_X, pos_Y;               // pozice na mape


long cas = 0;
#ifdef DEBUG_VERSION
FILE *debugfile;
#endif
//int btime_ = 0;    // cas dany timerem

/*
long get_cas()
{
    return cas;
}
*/

// CHEATS
int life_cheat;
//int nkotb_cheat;
int kill_civil_cheat;




void tovy_timer()
{
	long rozdil;
    //cas = (long)(clock() / (CLOCKS_PER_SEC / 100));
	//cas += (long)((clock()-spec_cas) / (CLOCKS_PER_SEC / 100));
	rozdil = (long)(((clock()-spec_cas) * 100) / (CLOCKS_PER_SEC));
	if (rozdil > 0)
	{
		cas += rozdil;
		//spec_cas = clock();
		spec_cas += rozdil * (CLOCKS_PER_SEC / 100);
	}
}


void tovy_timer_wait()
{
	spec_cas = clock();
}


void tovy_delay(int delay)
{
    long old_cas;
	tovy_timer();
	old_cas = cas;
	while (cas<old_cas+delay)
		tovy_timer();

}


void save_screen()
{
	save_bmp("screen.bmp", screen, pal);
}
